
#include "StdAfx.h"

#include "AVLTree.h"
#include "Dict.h"


CAVLNode::CAVLNode()
{
	left=right=NULL;
	balance=0;
//	val=NULL;
}

CAVLNode::~CAVLNode()
{
	if (left) delete left;
	if (right) delete right;
//	if (val) delete [] val;
}

CAVLNode* CAVLTree::Insert(xara_word& x,bool& bNew,int& d)
{
	int b=0; CAVLNode* n=NULL; bNew=false;
	if (m_root==NULL) {
		n=m_root=NewNode(L(""));
		bNew=true;
	}
	else m_root=m_root->Insert(x,b,n,bNew,d);
//	assert(b==0);
	return n;
}
/*

CAVLNode* CAVLTree::Insert(const xairo_uchar* w,bool& bNew)
{
	int b=0; CAVLNode* n=NULL; bNew=false;
	if (m_root==NULL) {
		n=m_root=NewNode(w);
		bNew=true;
	}
	else m_root=m_root->Insert(w,b,n,bNew);
//	assert(b==0);
	return n;
}
*/

#pragma optimize ("at",on)

CAVLNode* CAVLNode::Insert(xara_word& x,int& bal,CAVLNode*& n,bool& bNew,int& d)
{
// first find the insertion point
	int k=0; int b=0;
	bal=0;
	k=((_dnode*) this)->x.Compare(x);
/*
	xara_word* x1=&((_dnode*) this)->x.GetWord(); // better here to compare compressed forms
	k=memcmp(&x,x1,(size_t) 6*sizeof(int));
	if (k==0) {
		k=x.element-x1->element;
		for (int i=0;i<x.nco;i++) {
			if (k==0) k=x.con[i]-x1->con[i];
		}
		if (k==0)
			k=x.xval-x1->xval;
	}
*/
	if (k==0) {
		n=this;
		return n;
	}
	else if (k<0)
		if (left) {
				d++;
               left=left->Insert(x,b,n,bNew,d);
			   if (b != 0 && bNew) b=-1;
		}
		else {
			n=left=m_factory->NewNode(L("")); bNew=true;
			b=-1;
		}
	else 
		if (right) {
			d++;
			right=right->Insert(x,b,n,bNew,d);
			if (b != 0 && bNew) b=1;
		}
		else {
			n=right=m_factory->NewNode(L("")); bNew=true;
			b=1;
		}
// now calculate balances
	if (b) bal=balance+=b; else bal=0;
// now rebalance if necessary
	if (balance < -1) {
		bal=0;
		if (left->balance < 0) {
			balance=0;
			left->balance=0;
			CAVLNode* x=left;
			left=left->right;
			x->right=this;
			return x;
		} else 
			if (left->balance > 0) {
			int bb=left->right->balance;
			if (bb < 0) {
				left->balance=0;
				balance=1;
			} else if (bb==0) {
				left->balance=balance=0;
			} else {
				left->balance=-1;
				balance=0;
			}
			left->right->balance=0; // ?
			CAVLNode* w=left->right;
			left->right=w->left;
			w->left=left;
			left=w;
			CAVLNode* x=left;
			left=left->right;
			x->right=this;
			return x;
		} else assert(false);
	} else if (balance > 1) {
		bal=0;
		if (right->balance > 0) {
			balance=0;
			right->balance=0;
			CAVLNode* x=right;
			right=right->left;
			x->left=this;
			return x;
		} else if (right->balance < 0) {
			int bb=right->left->balance;
			if (bb > 0) {
				right->balance=0;
				balance=-1;
			} else if (bb==0) {
				right->balance=balance=0;
			} else {
				right->balance=1;
				balance=0;
			}
			CAVLNode* w=right->left;
			right->left->balance=0;
			right->left=w->right;
			w->right=right;
			right=w;
			CAVLNode* x=right;
			right=right->left;
			x->left=this;
			return x;
		} else assert(false);	
	} else ;
//	bal=balance;
	return this; 
}

/*
CAVLNode* CAVLNode::Insert(const xairo_uchar* w,int& bal,CAVLNode*& n,bool& bNew)
{
// first find the insertion point
	int k=0; int b=0;
	bal=0;
	const xairo_uchar* w1=w;
	const xairo_uchar* w2=val;
	while (*w1 && (k=(*w1++-*w2++))==0);
//	k=wcscmp(w,val);
	if (k==0) {
		n=this;
		return n;
	}
	else if (k<0)
		if (left) {
               left=left->Insert(w,b,n,bNew);
			   if (b != 0 && bNew) b=-1;
		}
		else {
			n=left=m_factory->NewNode(w); bNew=true;
			b=-1;
		}
	else 
		if (right) {
			right=right->Insert(w,b,n,bNew);
			if (b != 0 && bNew) b=1;
		}
		else {
			n=right=m_factory->NewNode(w); bNew=true;
			b=1;
		}
// now calculate balances
	if (b) bal=balance+=b; else bal=0;
// now rebalance if necessary
	if (balance < -1) {
		bal=0;
		if (left->balance < 0) {
			balance=0;
			left->balance=0;
			CAVLNode* x=left;
			left=left->right;
			x->right=this;
			return x;
		} else 
			if (left->balance > 0) {
			int bb=left->right->balance;
			if (bb < 0) {
				left->balance=0;
				balance=1;
			} else if (bb==0) {
				left->balance=balance=0;
			} else {
				left->balance=-1;
				balance=0;
			}
			left->right->balance=0; // ?
			CAVLNode* w=left->right;
			left->right=w->left;
			w->left=left;
			left=w;
			CAVLNode* x=left;
			left=left->right;
			x->right=this;
			return x;
		} else assert(false);
	} else if (balance > 1) {
		bal=0;
		if (right->balance > 0) {
			balance=0;
			right->balance=0;
			CAVLNode* x=right;
			right=right->left;
			x->left=this;
			return x;
		} else if (right->balance < 0) {
			int bb=right->left->balance;
			if (bb > 0) {
				right->balance=0;
				balance=-1;
			} else if (bb==0) {
				right->balance=balance=0;
			} else {
				right->balance=1;
				balance=0;
			}
			CAVLNode* w=right->left;
			right->left->balance=0;
			right->left=w->right;
			w->right=right;
			right=w;
			CAVLNode* x=right;
			right=right->left;
			x->left=this;
			return x;
		} else assert(false);	
	} else ;
//	bal=balance;
	return this; 
}
*/
#pragma optimize("",on)

CAVLTree::CAVLTree()
{
	m_root=NULL;
}

CAVLTree::~CAVLTree()
{
	if (m_root) delete m_root;
}

void CAVLTree::Draw()
{
	m_root->Draw(0);
}

void CAVLNode::Draw(int n)
{
	if (left) left->Draw(n+1);
	for (int i=0;i<n;i++)
		printf("\t");
//	printf("%S (%d)\n",val,balance);
	if (right) right->Draw(n+1);
}


