// Corpus.h: interface for the CCorpus class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CORPUS_H__32B7B813_1AC8_4C2B_AADA_8B38A3592C75__INCLUDED_)
#define AFX_CORPUS_H__32B7B813_1AC8_4C2B_AADA_8B38A3592C75__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef _WIN32
#include "SaraHeaderReader.h"
#else
#include "..\xaira-tools\SaraHeaderReader.h"
#endif

struct _tfl 
{
	UnicodeString name;
	_tfl* next;
};

namespace XERCES_CPP_NAMESPACE {
	class SAX2XMLReader;
}


class CCorpus  
{
public:
enum param {PARAM_ETCPATH,PARAM_NAME,PARAM_TEXTPATH,PARAM_ROOTPATH,PARAM_INDEXPATH,PARAM_HEADER,PARAM_TEMPPPATH,PARAM_LOG,PARAM_SOURCEPATH,PARAM_BIB,PARAM_VALIDATE,PARAM_GRAMMARCACHE,PARAM_MAX};
	UnicodeString GetPath(int);
	UnicodeString GetRelPath(int);
	UnicodeString GetName(int);
	UnicodeString GetBibPath();
	UnicodeString GetBibRelPath();
	UnicodeString GetBibName();
	int GetCount();
	void IndexPhase1();
	void IndexPhase2();
	void StartEntity(UnicodeString,UnicodeString);
	void EndEntity();
	int Status();
	bool IndexFile(UnicodeString,UnicodeString,UnicodeString,int,class CIndexer*);
	CCorpus(bool,bool,bool,bool,int,int,char*,char*);
	virtual ~CCorpus();
	void ReadParameters(const char*);
	UnicodeString Param(param);
	void ReadFileList();
	UnicodeString exppath(param,UnicodeString);
	bool m_bDump, m_bFreq, m_bHdr, m_bMem;
	int m_kLoc; char* m_cl;
	CSaraHeaderReader m_r;
	bool ReadHeader();
	UnicodeString GetSCPath(UnicodeString,UnicodeString);
	void DefSCs();
	void ClassNames(FILE*,_class*);
	void TestIndexDir();

	int m_nif;
	bool m_bib;
	int NText();
	CIndexer* m_ind;
private:
	int m_errorcount; int m_skip;
	void SetParam(UnicodeString,UnicodeString);
	UnicodeString param_vals[PARAM_MAX];
	void AddFile(UnicodeString);
	void BuildFileArray();
	UnicodeString* m_files;
	int m_nfiles;
	_tfl* m_tfl;
	class DHandle : public DefaultHandler {
		void fatalError(const SAXParseException&);
		void error(const SAXParseException&);
	};
	DHandle m_eh;
	static char* param_names[PARAM_MAX];
	void Options(CIndexer*);
	void OptionLabel(CIndexer*,_lab*);
	bool m_bMemoryErr, m_bDiskErr, m_bUnkErr, m_bCreateErr, m_bHdrErr;
	int m_nest;
	bool IllegalInFile(xairo_uchar);
	UnicodeString NormaliseSCName(UnicodeString);
	char* m_sBrk;
	SAX2XMLReader* m_parser;
	int m_nb;
	int m_kStr;

};

FILE* iopen(UnicodeString,const UChar*); 

#define MINLOCS 100000

#endif // !defined(AFX_CORPUS_H__32B7B813_1AC8_4C2B_AADA_8B38A3592C75__INCLUDED_)

