// Dict.h: interface for the CDict class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DICT_H__817B4D50_477A_4263_90F7_4D6424F678FC__INCLUDED_)
#define AFX_DICT_H__817B4D50_477A_4263_90F7_4D6424F678FC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "xarastruc.h"
#include "Locs.h"

#include "AVLTree.h"

//#define TROPT

#define MAXF 10

struct xara_lemma_0 {
	int freq;
	int forms;
	int nxt;
	xara_form* pt;
	int word[MAXF];
};


struct xwcomp {
/*	union {
		xara_word *m_w;
		int* con;
	} ptr;
	int val;
	enum typ t;
	int xval;
	int nco; */
	xara_word w;
	void SetWord(xara_word);
	xara_word* GetWord() {return &w;}
	~xwcomp();
	int Compare(xara_word);
};

struct _dnode : public CAVLNode 
{
	xwcomp x;
	int first, prev;
	int count; int countx;
	int ptr, ptr0, acc, sbn;
#ifdef TROPT
	xairo_uchar* maxt;
	_dnode* maxnode;
#endif TROPT
};

struct _tnode {
	xara_word ty;
	int first, last;
	_tnode* next;
};

struct _ca {
	UnicodeString name;
	bool index;
	UnicodeString def;
};


class CWordList;
class CCorpus;
//class XMLFormatter;

#define NLUMAX 5

class CDAVLTree : public CAVLTree
{
private:
	CAVLNode* NewNode(const xairo_uchar* w);
};

class CDict
{
public:
	int m_cr;
	void Save(int);
	void Close();
	void Index(typ,UnicodeString,UnicodeString,UnicodeString,UnicodeString,UnicodeString,UnicodeString,int, UnicodeString*, int,int,int,int,int);
	void Index(typ,UnicodeString,UnicodeString,UnicodeString,UnicodeString,UnicodeString,UnicodeString,int, UnicodeString*, int,UnicodeString,int,int,int);
	void Open(class CIndexer*,int,int,const char*);
//	_dnode* Add(xara_word w,_dnode**,xairo_uchar*,int&);
	int compare(xara_word w1,xara_word w2);
	_dnode* Add(xara_word w);
	_dnode* AddNew(xara_word& w);
	CDict(CCorpus*);
	virtual ~CDict();
	CDAVLTree* m_tree;
	_tnode* m_troot;
	CCorpus* m_corpus;
	int GetDepth() {return m_maxd0;}
	int GetSeq() {return m_loc.GetSeq();}
	void Typestats();
	void Report();
private:
	xairo_uchar* thingy(xara_word);
	int m_kloc;
	int m_band;
	int m_kstr;
//	void SaveBand();
	void SaveLocs2();
	void FUBand();
	void SaveBandNode(_dnode*);
	void SaveLocs2(_dnode*);
	void DelNode(_dnode*);
	int m_p;
	void SaveNode(_dnode*,int&,int);
	void SaveNodeOld(_dnode*,int&);
	CWordList* m_wl;
	CLocs m_loc;
	int m_maxd;
	int m_maxd0;
	FILE* m_df;
	FILE* m_dlf;
	int m_nd, m_nd0;
	void LemmaTable();
	void LemmaTable(int,int,int*);
	bool distinct(xara_word*,xara_word*);
	void DP(int&,_dnode*,int&);
	void LT0(xara_word&,_dnode*,int&);
	void LT1(xara_word&,xara_lemma_0 *&,_dnode*,int,int*);
	static int comp(const void*,const void*);
	static int slcomp(const void*,const void*);
	static int hs(const void*,const void*);
	class CIndexer *m_ind;
	void IndexWord(xara_word,xara_loc);
	int m_ncont;
	int m_ks;
	int m_lemma;
	int HW(xara_word,int);
	_ca* m_cont;
	int* m_co;
	void TypeLink();
	int AddWord(xara_word,int);
	bool MatchType(xara_word,xara_word); 
	void TypeList();
	bool HasAcc(xara_streambase*);
	int m_nodecount;
	_dnode* m_nlu[NLUMAX];
	int m_nnlu;
	int m_b;
	int m_nk[it_max];
	int m_nn[it_max];
	Locale* m_locale;
	int compare(xara_word*,xara_word*);

};

#endif // !defined(AFX_DICT_H__817B4D50_477A_4263_90F7_4D6424F678FC__INCLUDED_)
