// Locs.h: interface for the CLocs class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LOCS_H__FF564DC9_55E1_4AF0_9420_9B4854E9929B__INCLUDED_)
#define AFX_LOCS_H__FF564DC9_55E1_4AF0_9420_9B4854E9929B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "xarastruc.h"
#include "BigFile.h"

typedef unsigned char BYTE;

class CCorpus;
struct _dnode;

struct _acc {
	int* tab;
	int oldd;
	_acc* next;
};

struct _patch {
	int n, next;
};

class CAcc
{
public:
	CAcc(int);
	~CAcc();
	int New();
	void Entry(int,int,int);
	void Done(int,int);
	int Save(UnicodeString);
private:
	_acc* Get(int);
	_acc* m_a;
	int m_nt;
	int m_k;
	_acc** m_tail;
};
// 4/8/03 Add two new fields, a backptr to dnode and an offset in data 
struct locplus {
	xara_loc loc;
	int next; //int home; 
	int doc;
	int index;
	_dnode* dn; int ct;
	locplus() {}
	locplus(xara_loc l,int n):loc(l),next(n),/*home(-1),*/ doc(-1) {}
};

struct locplus0 {
	xara_loc loc;
	int index;
};

#define BBUFF 1000

struct _bite {
	FILE* fi;
	xairo_uchar path[_MAX_PATH];
	locplus0 b[BBUFF];
	int nb, limit, cursor;
	bool bEmpty;
};

class CLocs  
{
public:
	void Close2();
	void Open2(int,class CIndexer*);
	void SaveLocsOld(int,int,int,int);
	int Count();
	void Close();
	int Add(xara_loc,int,_dnode*,int);
	void Open(int);
	void Thread();
	void OldThread();
	CLocs(CCorpus*);
	virtual ~CLocs();
	int Accelerate();
	void Band();
	void EndBand();
	void FUBand();
	void FUEndBand();
	void SaveLocs0();
	void SaveLocs1();
	void Fixup0();
	void Fixup1();
	int StartAcc();
	int SaveLocsBand(int&,int,int,int);
	void FULocsBand();
	int m_band, m_kloc;
	void InitSaveLoc(), EndSaveLoc();
	void SaveLoc2();
	void SaveLoc3(int);
	int GetSeq() {return m_nl;}

private:
	int m_ok;
	void InitLift();
	inline int Cap(int n);
	bool WhereNext(int&);
	void Visit(int);
	static int lsort(const void*,const void*);
	void TermLift();
	int m_nb;
	locplus* m_lift;
	bool* m_called;
	void StartCompressedFile(int);
	void Compress(xara_loc*,int);
	void EndCompressedFile();
	xara_loc_hdr m_hdr;
	__int64 m_outp; int m_maxo, m_ink, m_np;
	BYTE* m_outb;
	xara_loc_page* m_page;
	int m_base;
	int m_bband;
	int m_base1;
	int m_bband1;
	int m_kkl;
	int m_ndf;
	int m_pbase;
	int m_oldacc;
	struct locplus* m_bb;
	struct locplus m_firstrec, m_lastrec;
//	struct xara_loc* m_bb1;
	int m_nq;
	int* m_tb;
	locplus* m_lb;
	CCorpus* m_corpus;
	FILE* m_collect;
//	CBigFile m_collect1;
	FILE* m_patch;
	int m_npatch;
	UnicodeString m_colls, m_colls1, m_pn;
	int m_nl;
	int m_count;
	int m_npage, m_nbite;
//	CPagedFile m_llf;
//	CBigFile m_if;
//	CBigFile m_lf;
	CPagedFile m_tf;
	CAcc* m_acc;
	void Compress();
	class CIndexer* m_ind;
	void Patch();
	void OldPatch();
	static int pcomp(const void*,const void*);
	_patch* m_pb;
	locplus* GetLoc(int);
	locplus* GetLocB(int,bool);
	int m_lastband;
	_bite* m_bite;
	void Compress0();
	void Compress1(int,int);
	void Compress2(int);
//	int m_maxi, m_maxo;
	CPagedFile m_cf;
	xara_loc* m_inb;
	__int64 m_usz, m_csz;
	void MergeBites(int);
	int MergeBites(int,int,FILE*,int);
	void Merges();
	void WriteThread(int*,int,bool=false);
	void OpenThread();
	void CloseThread();
	int* m_tp;
	BYTE* m_outbt;
	int m_sopt;
	int m_maxto;
	__int64 m_uszt, m_cszt;


};

#endif // !defined(AFX_LOCS_H__FF564DC9_55E1_4AF0_9420_9B4854E9929B__INCLUDED_)
