// SaraHeaderReader.h: interface for the SaraHeaderReader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SARAHEADERREADER_H__5DE87BBF_5BBC_497D_8411_A7150D46D9A0__INCLUDED_)
#define AFX_SARAHEADERREADER_H__5DE87BBF_5BBC_497D_8411_A7150D46D9A0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef _TOOLS

#include <unicode/uchar.h>
#include <unicode/unistr.h>
#include <unicode/ucnv.h>
#include <unicode/brkiter.h>
#include <unicode/coll.h>
#include <unicode/decimfmt.h>
#include <unicode/unorm.h>
#include <unicode/normlzr.h>

#include <xercesc/dom/DOM.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/sax2/DefaultHandler.hpp>
#include <xercesc/sax2/SAX2XMLReader.hpp>
#include <xercesc/sax2/XMLReaderFactory.hpp>
#include <xercesc/sax2/Attributes.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/util/XMLUniDefs.hpp>
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/TransService.hpp>
#include <xercesc/util/TranscodingException.hpp>
#include <xercesc/framework/XMLFormatter.hpp>
#include <xercesc/framework/LocalFileFormatTarget.hpp>
#include <xercesc\framework\LocalFileInputSource.hpp>
#include <xercesc/framework/MemBufInputSource.hpp>
#include <xercesc/sax/SAXException.hpp>
#include <xercesc/sax/SAXParseException.hpp>
#include <xercesc\sax\InputSource.hpp>
#include <xercesc/sax/Locator.hpp>
#include <xercesc/parsers/XercesDOMParser.hpp>

typedef wchar_t xairo_uchar;

#define L(x) L ## x

#endif
namespace XERCES_CPP_NAMESPACE { }




using namespace XERCES_CPP_NAMESPACE;

enum indexpol {IP_CDATA,IP_NONE,IP_TAX,IP_IDREF,IP_ID,IP_CONTENT,IP_MAX_LOCAL=IP_CONTENT,IP_LEMMA,IP_CONTENTA,IP_MAX};
//enum indexpol0 {IP0_CONTENT,IP0_NONE,IP0_MARKUP,IP0_WTAG,IP0_MAX};

#define EIP_MASK 3
#define EIP_SHIFT 2
#define EIP_THIS(x) (x & EIP_MASK)
#define EIP_CONTENT(x) ((x & (EIP_MASK << EIP_SHIFT)) >> EIP_SHIFT)
#define EIP_CHILDREN(x) ((x & (EIP_MASK << (EIP_SHIFT*2))) >> (EIP_SHIFT+2))
#define EIP_MAKE(x,y,z) (x | (y << EIP_SHIFT) | (z << (EIP_SHIFT*2)))
#define EIP_YES 1
#define EIP_NO 0
#define EIP_INHERIT 2
#define EIP_DEFAULT EIP_MAKE(EIP_INHERIT,EIP_INHERIT,EIP_INHERIT)



struct _code {
	UnicodeString code;
	UnicodeString desc;
	_code () {code=desc="";}
};


struct _attusage {
	UnicodeString name;
	UnicodeString uri;
	UnicodeString gloss;
	UnicodeString target;
	indexpol ip;
	bool bCB;
	int nc;
	int nw; // reserved for wizard
	_code* cb;
	bool bT; //scratch memory
	_attusage() {name=""; uri=""; gloss=""; bCB=false; cb=NULL; nc=0; ip=IP_CDATA; nw=0;}
};


struct _tagusage {
	UnicodeString name;
	UnicodeString uri;
	UnicodeString gloss;
	int occurs;
	int natts;
	_attusage* atts; 
	unsigned ip;
	bool wb;
	void* data;
	_tagusage() {name=""; gloss=""; uri=""; ip=EIP_DEFAULT; natts=0; atts=NULL; wb=false;}
};


enum sp_elt {SPE_LINE,SPE_FILE};

struct _lab {
	int ne;
	UnicodeString* elt;
	UnicodeString ns, ans;
	bool bGlob;
	UnicodeString att;
	bool isAuto;
	bool isSpec;
	bool isMilestone;
	bool isScope;
	sp_elt e;
	UnicodeString fmt;
	int seq;
	bool bdef;
	UnicodeString cache;
	_lab() {elt=NULL; ns=ans=""; att=""; isAuto=false; isSpec=false; isMilestone=false; isScope=false; ne=0; bGlob=false;}
};

struct _class {
	UnicodeString id;
	UnicodeString desc;
	int n; 
	_class* l;
};


struct _taxonomy {
	UnicodeString id;
	UnicodeString desc;
	UnicodeString unclass;
	int n;
	_class* l;
	bool hastax;
};

struct _addkey {
	enum akproc {AKP_FORM,AKP_TAG};
	enum defproc {DP_USEVAL,DP_USEFORM};
	UnicodeString name;
	UnicodeString desc;
	UnicodeString ans;
	akproc proc;
	int ngi;
	UnicodeString* gi;
	UnicodeString att;
	bool isLemma;
	bool isPseudo;
	bool bCaseSensitive;
	defproc dproc;
	UnicodeString defval;
	bool bdef, bInd;
	UnicodeString cache;
	_addkey():name(""),desc(""),proc(AKP_TAG),
		ngi(0),gi(NULL),att(""),isLemma(false),dproc(DP_USEFORM),defval(""),
		isPseudo(false),bdef(false) {}
	_addkey& operator= (const _addkey&);
};

struct _ls {
	UnicodeString name;
	UnicodeString desc;
	int n;
	UnicodeString* a;
	_ls():name(""),desc(""),n(0),a(NULL){}
	_ls& operator= (const _ls&);
};

struct _region {
	UnicodeString name;
	UnicodeString desc;
	int n;
	UnicodeString* a;
	int nak;
	_region():name(""),desc(""),n(0),a(NULL),nak(-1){}
	_region& operator= (const _region&);
};

#define MAXLANG 10
#define MAXLOCALE 100

struct _lang {
	UChar id[MAXLANG];
	UnicodeString desc;
	char locale[MAXLOCALE];
	bool bUserTokenRules;
	UnicodeString rules;
	_lang() {id[0]=0;locale[0]=0; bUserTokenRules=false; }
};

struct _bib {
	int start;
	int length;
};

struct _wtag {
	UnicodeString s;
};

struct _entity {
	xairo_uchar ch;
	xairo_uchar* name;
};

enum hd_section {HD_ADDKEYS,HD_REFS,HD_IPS,HD_CODEBOOKS,HD_BIBTAGS,HD_BIBRULES,HD_LEMMASCHEMES,HD_REGIONS,HD_TAGUSAGE};

struct _valsource
{
	const xairo_uchar* type;
	const xairo_uchar* ident;
	const xairo_uchar* ns;
	const xairo_uchar* gloss;
	const xairo_uchar* def;
	int ngi;
	const xairo_uchar** gi;
	bool bdefform;
	bool bcasefold;
	_valsource();
};

enum header_error {HE_ROOT,HE_UNDEF_ATTRIBUTE,HE_NOIDENT,HE_BAD_EIP,HE_MISSING_SECTION,HE_UNDEF_ADDKEY,
	HE_DUP_CODE,HE_BAD_ELT,HE_REGION_ADDKEY,HE_UNDEF_ELEMENT,
	HE_UNDEF_POLICY,HE_BIBFILE,HE_MAX};

class CSaraHeaderReader  
{
public:
	bool IsGlobal(const xairo_uchar*,const xairo_uchar*,const xairo_uchar*,const xairo_uchar*);
	int TestWTag(const xairo_uchar*);
	bool TestWB(const xairo_uchar*);
	CSaraHeaderReader();
	virtual ~CSaraHeaderReader();
	void GetLabels();
	void SetLabels();
	void GetLabelsOld();
	void SetLabelsOld();
	void DecodeLabel(const xairo_uchar*,const xairo_uchar*,_lab*,bool&);
	void DecodeLabel2(_valsource*,_lab*);
	void EncodeLabel(_lab*,UnicodeString&,UnicodeString&); 

	void GetTagUsage();
	void GetTagUsageOld();
	void SetTagUsage();
	void SetAttInList2(_attusage*,DOMElement*);

	void DelTagUsage();
	void DelAttUsage(int,_attusage*);
	void GetBibTagUsage();
	void SetBibTagUsage();
	int Read(UnicodeString);
	bool OldStyle();
	bool m_bExists;
//	void HeaderErr(hd_section,const char*);
	XERCES_CPP_NAMESPACE::DOMDocument* m_doc;
	void GetAttUsage(DOMElement*,int&,_attusage*&);
	void GetAttUsage2(DOMElement*,int&,_attusage*&);
	_tagusage* m_tagusage;
	_tagusage* m_btagusage;
	UnicodeString* m_ns;
	int m_nns;
	int m_ntags, m_nbtags;
	_lab* m_labels;
	UnicodeString m_nulllab;
	int m_nlabels;
//	UnicodeString m_ulfs;
	int m_nglobatts;
	_attusage* m_globals;
	bool m_bUpdate;
	indexpol LookupIP(const UChar*);
	static UnicodeString ipname[IP_MAX];
	static UnicodeString ipnname[IP_MAX];
//	static UChar* ip0name[IP0_MAX];
	indexpol GetIP(UnicodeString,UnicodeString); 
	unsigned GetIP0(UnicodeString,UnicodeString); 
	int CountTax();
	int CountTax(int,_class*);
//	int GetTaxClass(UnicodeString);
//	int GetTaxClass(UnicodeString,int,_class*, UnicodeString);
//	int GetTaxClasses(UnicodeString,UnicodeString*&,UnicodeString*&);
	int GetTaxClasses(UnicodeString s,UnicodeString*& vals);
	bool GetTaxClass(_taxonomy*,int,int&,UnicodeString*,bool*,UnicodeString&);
	bool FindClass(UnicodeString,_class*,int,int&);
	UnicodeString GetToken(UnicodeString&);
	void GetTaxonomies();
	int GetClassList(DOMElement*,_class*&);
	_taxonomy* m_taxonomies;
	int m_ntax;
	int GetSCPart(_taxonomy*,UnicodeString);
	bool ClassToInt(_class*,UnicodeString,int&,int&);
	bool IsTax(UnicodeString);
//	int m_ncont;
//	xairo_uchar** m_cont;
//	const char** m_acont;
	int m_lemma;
	void GetAddKeys();
	void SetAddKeys();
	void GetAddKeysOld();
	void SetAddKeysOld();
	void CopyOldAKStruc();
	DOMElement* GetNamedList(DOMElement*,const xairo_uchar*);
	DOMElement* GetNamedList2(DOMElement*,const xairo_uchar*);
	DOMElement* GetNamedNote(DOMElement*,const xairo_uchar*);
	DOMElement* GetUniqueNode(const xairo_uchar*);
	bool TestItem(DOMNode*,const xairo_uchar*);
	_addkey* m_addkeys;
	_ls* m_ls;
	int m_naddkeys, m_nls;
	int m_rak;
	int m_nreg;
	_region* m_reg;
	int m_nwtags;
	_wtag* m_wtags;
	const xairo_uchar* GetContent(DOMNode*);
	UnicodeString GetContentNS(DOMNode*);
	void GetLangs();
	void SetLangs();
	_lang* m_langs;
	_lang* m_deflang;
	int m_nlangs;
	void Clean(DOMNode*);
	virtual void StructureError(const char*);

	void GetCodeBooks();
	void SetCodeBooks();
	void GetIPSpec();
	void SetIPSpec();
	void SetIPSpecA(DOMElement*,_attusage*,const xairo_uchar*);
	void GetIPSpecOld();
	void SetIPSpecOld();
	_attusage* GetAttUsage(UnicodeString gi,UnicodeString att);
	_attusage* GetAttUsage(UnicodeString gi,UnicodeString att,UnicodeString url);
	_tagusage* GetTagUsage(UnicodeString gi);
	_tagusage* GetTagUsage(UnicodeString gi,UnicodeString url);
	void SetCodeBook(_attusage*,DOMNode*);
	void GetCodeBook(_attusage*,DOMNode*);
	void ParseIP(const UChar*,const UChar*,const UChar*,const UChar*);
	DOMElement* GetHeaderSection(hd_section);
	DOMElement* SetHeaderSection(hd_section);
	DOMElement* GetXairaRoot();
	void HeaderError(header_error,bool,const xairo_uchar*,...);
//	void HeaderError(header_error,bool,const char*,...);
	bool (*m_error_handler)(header_error,const xairo_uchar*,void*);
	void* m_lparam;
	void SetErrorHandler(bool (*eh)(header_error,const xairo_uchar*,void*),void* v) {
		m_error_handler=eh; m_lparam=v;
	}
	class BHandle : public DefaultHandler {
	public:
		void startElement(const XMLCh* const,const XMLCh* const,const XMLCh* const,const Attributes&);
		void endElement(const XMLCh* const,const XMLCh* const,const XMLCh* const,const Attributes&);
		void fatalError(const SAXParseException&);
		void error(const SAXParseException&);
		void characters(const XMLCh* const,const unsigned int);
	};
	bool ReadBib(UnicodeString);
	_bib* m_bib;
	int m_nbib;
	DOMElement* GetEncodingDesc();
	void DelClass(_class*);
	void DelTaxonomies();
	void DescTax(FILE*,const UChar*);

	int m_nerrs;
	void IncErrCount() {m_nerrs++;}
	void ZeroErrCount() {m_nerrs=0;}
	int ErrCount() {return m_nerrs;}

	void MakeDSC(UnicodeString);
	void GetEntities();
	_entity* m_ents;
	int m_nents;
	void GetRanges();
	UnicodeString* m_uranges;
	int m_nuranges;
	void DefAddKey(_addkey*);
	bool DecodeEWB(UnicodeString&);
	unsigned DecodeEIP(UnicodeString);
	unsigned DecodeEIP2(UnicodeString);
	UnicodeString CodeEIP(unsigned);
	UnicodeString CodeEIP2(unsigned);
	void CodeEWB(bool,UnicodeString&);
	bool m_bConverting;
	DOMElement* MakeValSource(_valsource*);
	void GetValSource(DOMElement*,_valsource*);
	int Region(UnicodeString);
//
};

DOMElement* GetChildByTag(DOMNode*,const XMLCh*);
const XMLCh* GetContent(DOMNode*);
const char* Ascii(const XMLCh*);
const char* Ascii(UnicodeString);
UnicodeString Wide(const char*);
int swcmp(const char* c,const xairo_uchar* w);

class CHeaderError
{
};


#endif // !defined(AFX_SARAHEADERREADER_H__5DE87BBF_5BBC_497D_8411_A7150D46D9A0__INCLUDED_)
