// TextReader.h: interface for the CTextReader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TEXTREADER_H__C6476911_8333_465A_92F2_AB46A0B4F090__INCLUDED_)
#define AFX_TEXTREADER_H__C6476911_8333_465A_92F2_AB46A0B4F090__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define MAXENCODING 128

class CIndexer; 

class CTextReader  
{
public:
	int GetLineOffset(int);
	bool Read(int&);
	CTextReader(UnicodeString,CIndexer*);
	virtual ~CTextReader();
	UnicodeString m_path;
	UnicodeString m_input;
	UnicodeString m_enc;
	int Offset(int,int);
	void Free();
	int Lines() {return m_nlines;}
	int LineLength(int i) {return m_linels[i-1];}
	class InputSource* GetInputSource();
	void Premap(int,int);
	void Premap2(int,int);
	static void DumpAll(const char*);
private:
	int m_pc, m_pl, m_po;
	int m_pc2, m_pl2, m_po2;
	int m_pc3, m_pl3, m_po3;
	void RecordLine(int);
	long GuessEncoding(char*,int);
	void LineLengths();
	int m_i, m_j;
	int *m_lines;
	UnicodeString m_d;
	int m_p;
	unsigned char *m_cs;
	XMLSize_t m_b;
	int m_kk;
	int m_oldd,	m_oldk, m_oldli, m_oldco;
	bool m_bold;
	int m_nlines;
	int *m_linels;
	int* m_lineo;
	CIndexer* m_ind;
	bool XercesTranscode(const char*,XMLSize_t);
	bool ICUTranscode(const char*,int);

};

#endif // !defined(AFX_TEXTREADER_H__C6476911_8333_465A_92F2_AB46A0B4F090__INCLUDED_)
