#pragma once

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//#include <xercesc/util/XMLString.hpp>

#include "xarastruc.h"

class CWordList {
	friend class CDict;
public:
	CWordList();
	~CWordList();
	int Add(const xairo_uchar*);
	int ExpAdd(const xairo_uchar*);
	int Add(UnicodeString& s) {return Add((const xairo_uchar*) s.getTerminatedBuffer());}
//	UnicodeString Get(int);
	const xairo_uchar* Get(int);
	void Save(UnicodeString,int,xara_wl_header_addkey*,int,int,xara_wl_header_tax*,int);
	int GetSymbols() {return m_next;}
	int GetHashSize() {return m_hashsize;}
	int GetLHC() {return m_lhc;}
	int GetChars() {return m_nchars;}
	int GetMaxWL() {return m_nmaxword;}
	int GetMaxW() {return m_maxword;}
	void Dump();
private:
	int m_nmaxword;
	int m_maxword;
	void Expand();
	int hash(const xairo_uchar*);
	int m_init, m_expand;
	int m_places;
	int m_shift;
	int m_hashsize, m_size;
	int* m_idx;
	xara_wl* m_tab;
	int m_next;
	bool m_bExp;
	int m_lhc;
	int m_nchars;
};


