#pragma once

#define DBVER 26
#define DBSIG 0x00006978
#define DBSIGR 0x78690000

#define XAIRA_URI "http://xaira.org/ns/1.0"
#define XAIRA_URIL L("http://xaira.org/ns/1.0")

enum typ {it_content,it_start,it_end,it_pi,it_global_attribute,it_local_attribute,it_global_attribute_value,
	it_local_attribute_value,it_content_attribute,it_enddoc,it_addkey,it_spm,it_epm,it_max};

#pragma pack(push,4)

struct xara_word {
	int val;
	enum typ t;
	int uri;
	int name;
	int euri;
	int element;
	int xval;
	int nco;
	int* con;
	xara_word() {}
	xara_word(typ t0,int u,int n,int eu,int e,int v,int xv,int nc,int* co ):
	t(t0),uri(u),name(n),euri(eu),element(e),val(v),xval(xv),nco(nc),con(co) {}
};

struct xara_loc {
	int fi;
	int nw;
	int off;
	int len;
	int sb;
//	int pre, nxt;
	int seq;
	int parent;
	xara_loc() {}
	xara_loc(int i1,int i2,int i3,int i4,int i5):fi(i1),nw(i2),off(i3),len(i4),parent(i5) {}
};

struct xara_streambase{
	xara_word w;
	int first;
	int count;
	int nxt; // next of same type
	int acc;
};

struct xara_form {
	int ptr;
	int count;
	int freq;
};

struct xara_lemma {
	int freq;
	int forms;
	int nxt;
	xara_form* pt;
	int word[1];
};


struct xara_lemma_header {
	int maxpos;
	int ndix;
	int nu;
	int nfacets;
};

struct xara_wl {
	const xairo_uchar* word;
	int next;
	int dicptr;
};

struct xara_wl_file {
	int len;
	int next;
	int dicptr;
};


struct xara_wl_header {
	unsigned sig;
	unsigned version;
	int size;
	int hashsize;
	int places;
	int shift;
	int cont;
	int lemma;
	int ntax;
	int nls;
};

struct xara_wl_header_addkey {
	int name;
	int bLemma;
	int def;
};

struct xara_wl_header_tax {
	int name;
	int nc;
};


struct xara_type {
	typ t;
	int element;
//	int euri;
	int att;
//	int auri;
	int first;
};

struct xara_ahdr {
	int nt;
	int na;
};

struct xara_loc_hdr {
	int ps;
	int strength;
	int np;
	int nf;
	int maxpage;
};

struct xara_loc_page {
	int fi;
	unsigned off;
	int len;
};

#pragma pack(pop)

