#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_NON_CONFORMING_SWPRINTFS
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#ifdef _WIN32
#include <windows.h>
#endif
#include "../XairoHeader.h"
#include "XairaServer.h"


#ifndef _WIN32
#define _tempnam tempnam
extern "C" int XServer(const xairo_uchar*,xairo_uchar**);
extern "C" int InitServer(const char*,BOOL (*)(void),BOOL,const char*,const char*);
#else
extern "C" __declspec(dllimport) int XServer(const xairo_uchar*,xairo_uchar**);
extern "C" __declspec(dllimport) int InitServer(const char*,BOOL (*)(void),BOOL,const char*,const char*);
#endif

CXairaSaraServer::CXairaSaraServer(void)
{
}

CXairaSaraServer::~CXairaSaraServer(void)
{
}

xairo_uchar* uc(const char* s)
{
	int t=0;
	for (int i=0;s[i];i++) {
		char c=s[i];
		int cc=c & 0xE0;
		if (cc==0xE0) i+=2;
		else if (cc==0xC0) i++;
		t++;
	}
	xairo_uchar* w=new xairo_uchar[t+1];
	t=0;
	for (int i=0;s[i];i++) {
		char c=s[i];
		int cc=c & 0xE0;
		if (cc==0xE0) {
			w[t]=((s[i] & 0xf) << 12) +((s[i+1] & 0x3f) << 6) +(s[i+2] & 0x3f);
			i+=2;
		} 
		else if (cc==0xC0) {
			w[t]=((s[i] & 0xf) << 6) +(s[i+1] & 0x3f);
			i++;
		}
		else w[t]=s[i];
		t++;
	}
	w[t]=0;
	return w;
}




char* utf8(const xairo_uchar* w)
{
	int t=0;
	for (int i=0;w[i];i++) {
		if (w[i] <= 0x7f) t++;
		else if (w[i]<=0x7ff) t+=2;
		else t+=3;
	}
	char* s=new char[t+1];
	int j=0;
	for (int i=0;w[i];i++) {
		xairo_uchar x=w[i];
		if (x <= 0x7f) {
			s[j++]=(char) x;
		}
		else if (x <= 0x7ff){
			s[j++]=(char) (((x & 0x7C0)>>6) | 0xC0);
			s[j++]=(char) ((x & 0x3f)|0x80);
		}
		else {
			s[j++]=(char) (((x & 0xf000) >> 12) | 0xE0);
			s[j++]=(char) (((x & 0xFC0) >> 6) | 0x80);
			s[j++]=(char) ((x & 0x3F) |0x80);
		}
	}
	s[j]=0;
	return s;
}




const char* CXairaSaraServer::Exec(const char* s)
{
	xairo_uchar* tx=NULL;
	XServer(uc(s),&tx);
	return utf8(tx);
}

BOOL CXairaServer::TestInterrupt()
{
	return FALSE;
}

#define BL 1000

bool CXairaSaraServer::Init(const char* path,bool b,char*)
{
	char tp[_MAX_PATH];
#ifdef _WIN32
	GetTempPathA(_MAX_PATH,tp);
#else
	strcpy(tp,"/tmp/");
#endif
	char bl[_MAX_PATH];
	strcpy(bl,_tempnam(tp,"serverbootlog"));
	bool bOK=(InitServer(path,TestInterrupt,b?TRUE:FALSE,tp,bl)==TRUE);
	if (!bOK) {
		FILE* f=fopen(bl,"r");
		if (f==NULL)
			printf("Unknown error starting server\n");
		else {
			char bu[BL];
			while (fgets(bu,BL,f)) {
				printf("%s",bu);
			}
			fclose(f);
		}
	}
	remove(bl);
	return bOK;
}

