#include <stdarg.h>
#include <string.h>
#ifdef _WIN32
#include <windows.h>
#endif

#include <unicode/unistr.h>

#include "../XairoHeader.h"

#include "XairaXMLServer.h"



class MyBootLog : public CXairoIBootMonitor
{
public:
	void Log(const xairo_uchar* u);
};


CXairaXMLServer::CXairaXMLServer(void)
{
}

CXairaXMLServer::~CXairaXMLServer(void)
{
}

const char* CXairaXMLServer::Exec(const char* s)
{
	m_int->Reset();
	return m_server->Transport(s);
}


bool CXairaXMLServer::Init(const char* path,bool b,char* name)
{
	m_int=new CXairaXMLInt;
	MyBootLog bm;
	CXairoIParameters xp;
	xp.parameter_file=path;
	xp.bm=&bm;
	xp.inth=m_int;
#ifdef _WIN32
	char tp[_MAX_PATH];
	GetTempPathA(_MAX_PATH,tp);
	xp.temppath=tp;
	int tx=strlen(tp);
	if (tp[tx-1]=='\\') tp[tx-1]=0;
	char dp[_MAX_PATH];
	GetModuleFileNameA(NULL,dp,_MAX_PATH);
	char* x=strrchr(dp,'\\');
	*x=0;
	xp.datapath=dp;
#else
	xp.temppath="/tmp";
	xp.datapath=DATAPATH;
#endif
	CXairoInterface* s=CXairoImplementation::getServer(&xp);
	if (s==NULL) return false;
	UnicodeString n(s->getCorpusName());
	n.extract(0,n.length(),m_cname);
	m_server=CXairoImplementation::getStubServer(s);
	m_ver=CXairoImplementation::getAPIVersion();
//	m_cname="";
	return true;
}

	
