#pragma once


#include "XairaServer.h"
#include "../XairoHeader.h"

using namespace XAIRO_NAMESPACE;

class CXairaXMLInt : public CXairoIInterruptHandler
{
public:
	CXairaXMLInt():m_bInt(false) {}
	bool testInterrupt() {return m_bInt;}
	void Interrupt() {m_bInt=true;}
	void Reset() {m_bInt=false;}
private:
	bool m_bInt;

};

class CXairaXMLServer : public CXairaServer
{
public:
	CXairaXMLServer(void);
	~CXairaXMLServer(void);
	bool Init(const char* path,bool bLog,char*);
	const char* Exec(const char*);
	void Interrupt() {m_int->Interrupt();}
	unsigned getAPIVersion() {return m_ver;}
	const char* getCorpusName() {return m_cname;}
private:
	CXairoIStubServer* m_server;
	CXairaXMLInt* m_int;
	bool m_bInt;
	unsigned m_ver;
	char m_cname[_MAX_PATH];
};
